
define(['require','modules/settings_panel','modules/addon_manager','panels/addon_details/addon_details','modules/settings_service','modules/dialog_service','shared/toaster','shared/manifest_helper'],function(require){'use strict';var SettingsPanel=require('modules/settings_panel');var AddonManager=require('modules/addon_manager');var AddonDetails=require('panels/addon_details/addon_details');var SettingsService=require('modules/settings_service');var DialogService=require('modules/dialog_service');var Toaster=require('shared/toaster');var ManifestHelper=require('shared/manifest_helper');return function ctor_addon_details_panel(){return SettingsPanel({onInit:function(panel){this._elements={body:panel.querySelector('.addon-details-body'),header:panel.querySelector('.addon-details-header'),gaiaHeader:panel.querySelector('gaia-header'),enabledState:panel.querySelector('.addon-enabled-state'),name:panel.querySelector('.addon-details-name'),icon:panel.querySelector('.addon-details-icon'),description:panel.querySelector('.addon-description-text'),developer:panel.querySelector('.addon-developer'),targetsList:panel.querySelector('.addon-targets'),toggle:panel.querySelector('.addon-enabled'),deleteButton:panel.querySelector('.addon-delete'),renameButton:panel.querySelector('.addon-rename')};this._details=AddonDetails(this._elements);this._boundOnAppEnabledChange=this._onAppEnabledChange.bind(this);this._elements.toggle.onchange=this._onToggleChange.bind(this);this._elements.deleteButton.onclick=this._onDelete.bind(this);this._elements.renameButton.onclick=this._onRename.bind(this);},onBeforeShow:function(panel,options){return Promise.resolve((()=>{if(options.addon){return options.addon;}else if(options.manifestURL){return AddonManager.findAddonByManifestURL(options.manifestURL);}})()).then((addon)=>{this._curAddon=addon;if(this._curAddon){this._details.render({app:this._curAddon,isActivity:!options.addon});this._elements.toggle.checked=AddonManager.isEnabled(this._curAddon);this._curAddon.observe('enabled',this._boundOnAppEnabledChange);this._elements.deleteButton.disabled=!AddonManager.canDelete(this._curAddon);this._elements.body.hidden=false;}else{console.error('No valid add-on');this._elements.body.hidden=true;}
this._elements.gaiaHeader.hidden=false;});},onHide:function(){this._elements.body.scrollTop=0;if(this._curAddon){this._curAddon.unobserve('enabled',this._boundOnAppEnabledChange);this._curAddon=null;}},_showStepsRequired(type){if(type==='reboot'){Toaster.showToast({messageL10nId:'addon-reboot-required',latency:3000,useTransition:true});}else if(type==='restart'){Toaster.showToast({messageL10nId:'addon-restart-apps-to-disable',latency:3000,useTransition:true});}},_onAppEnabledChange:function(enabled){this._elements.toggle.checked=enabled;if(!enabled){AddonManager.getAddonDisableType(this._curAddon).then(this._showStepsRequired);}},_onToggleChange:function(){if(this._elements.toggle.checked){AddonManager.enableAddon(this._curAddon);}else{AddonManager.disableAddon(this._curAddon);}},_onDelete:function(){this._elements.deleteButton.disabled=true;var disableType;AddonManager.getAddonDisableType(this._curAddon).then(type=>{disableType=type;return AddonManager.deleteAddon(this._curAddon);}).then(()=>{this._showStepsRequired(disableType);SettingsService.navigate('addons');}).catch(reason=>{console.error('Addon deletion failed:',reason);this._elements.deleteButton.disabled=false;});},_onRename:function(){var manifest=new ManifestHelper(this._curAddon.instance.manifest||this._curAddon.instance.updateManifest);DialogService.prompt('addon-rename-desc',{title:'addon-rename-input',defaultValue:manifest.name,submitButton:'ok',cancelButton:'cancel'}).then(result=>{var type=result.type;if(type!=='submit'){return;}
var value=result.value.trim();if(!value){return;}
AddonManager.renameAddon(this._curAddon,value).then(addon=>{this._curAddon=addon;this._details.updateNames(new ManifestHelper(addon.instance.manifest||addon.instance.updateManifest));}).catch(reason=>{console.error('Addon renaming failed:',reason);});});}});};});