
define('panels/root/bluetooth_item',['require','modules/bluetooth/version_detector','modules/settings_service'],function(require){'use strict';var APIVersionDetector=require('modules/bluetooth/version_detector');var SettingsService=require('modules/settings_service');var APIVersion=APIVersionDetector.getVersion();var _debug=false;var Debug=function(){};if(_debug){Debug=function bti_debug(msg){console.log('--> [BluetoothItem]: '+msg);};}
function BluetoothItem(element){this._enabled=false;this._element=element;this._boundRefreshMenuDescription=this._refreshMenuDescription.bind(this,element);}
BluetoothItem.prototype={_APIVersion:function bt__APIVersion(){return APIVersion;},_getBluetoothPromise:null,_getBluetooth:function bt__getBluetooth(){if(!this._getBluetoothPromise){this._getBluetoothPromise=new Promise(function(resolve){var bluetoothModulePath;if(this._APIVersion()===1){bluetoothModulePath='modules/bluetooth/bluetooth_v1';}else if(this._APIVersion()===2){Debug('loading.. modules/bluetooth/bluetooth_context');bluetoothModulePath='modules/bluetooth/bluetooth_context';}
require([bluetoothModulePath],resolve);}.bind(this));}
return this._getBluetoothPromise;},_refreshMenuDescription:function bt__refreshMenuDescription(element){if(!navigator.mozL10n){return;}
this._getBluetooth().then(function(bluetooth){Debug('Got bluetooth context');if(bluetooth.enabled){if(bluetooth.numberOfPairedDevices===0){element.setAttribute('data-l10n-id','bt-status-nopaired');}else{navigator.mozL10n.setAttributes(element,'bt-status-paired',{name:bluetooth.firstPairedDeviceName,n:bluetooth.numberOfPairedDevices-1});}}else{element.setAttribute('data-l10n-id','bt-status-turnoff');}});},get enabled(){return this._enabled;},set enabled(value){if(this._enabled===value){return;}
this._enabled=value;this._getBluetooth().then(function(bluetooth){if(this._enabled){bluetooth.observe('enabled',this._boundRefreshMenuDescription);bluetooth.observe('numberOfPairedDevices',this._boundRefreshMenuDescription);this._boundRefreshMenuDescription();}else{bluetooth.unobserve('enabled',this._boundRefreshMenuDescription);bluetooth.unobserve('numberOfPairedDevices',this._boundRefreshMenuDescription);}}.bind(this));},_navigatePanelWithVersionCheck:function bt__navigatePanelWithVersionCheck(){if(this._APIVersion()===1){SettingsService.navigate('bluetooth');}else if(this._APIVersion()===2){Debug('navigate bluetooth_v2 panel');SettingsService.navigate('bluetooth_v2');}}};return function ctor_bluetoothItem(element){return new BluetoothItem(element);};});define('panels/root/nfc_item',['require','shared/settings_listener'],function(require){'use strict';var SettingsListener=require('shared/settings_listener');function NFCItem(elements){if(!navigator.mozNfc){return;}
elements.nfcMenuItem.hidden=false;this._checkbox=elements.nfcCheckBox;this._checkbox.addEventListener('change',()=>this._onCheckboxChanged());SettingsListener.observe('nfc.status',undefined,(status)=>this._onNfcStatusChanged(status));}
NFCItem.prototype={_onCheckboxChanged:function ni_onCheckboxChanged(){this._checkbox.disabled=true;},_onNfcStatusChanged:function ni_onNfcStatusChanged(status){if(status==='enabling'||status==='disabling'){this._checkbox.disabled=true;}else if(status==='enabled'||status==='disabled'){this._checkbox.disabled=false;}}};return function ctor_nfcItem(elements){return new NFCItem(elements);};});define('panels/root/language_item',['require','shared/language_list'],function(require){'use strict';var LanguageList=require('shared/language_list');function LanguageItem(element){this._enabled=false;this._boundRefreshText=this._refreshText.bind(this,element);}
LanguageItem.prototype={_refreshText:function l_refeshText(element){LanguageList.get(function displayLang(languages,currentLanguage){element.textContent=LanguageList.wrapBidi(currentLanguage,languages[currentLanguage]);});},get enabled(){return this._enabled;},set enabled(value){if(this._enabled===value||!navigator.mozL10n){return;}
this._enabled=value;if(this._enabled){window.addEventListener('localized',this._boundRefreshText);this._boundRefreshText();}else{window.removeEventListener('localized',this._boundRefreshText);}}};return function ctor_languageItem(element){return new LanguageItem(element);};});define('panels/root/battery_item',['require','modules/battery'],function(require){'use strict';var Battery=require('modules/battery');function BatteryItem(element){this._enabled=false;this._element=element;this._boundRefreshText=this._refreshText.bind(this,element);}
BatteryItem.prototype={_refreshText:function b_refreshText(element){if(!navigator.mozL10n){return;}
navigator.mozL10n.setAttributes(element,'batteryLevel-percent-'+Battery.state,{level:Battery.level});if(element.hidden){element.hidden=false;}},get enabled(){return this._enabled;},set enabled(value){if(this._enabled===value){return;}
this._enabled=value;if(this._enabled){Battery.observe('level',this._boundRefreshText);Battery.observe('state',this._boundRefreshText);this._boundRefreshText();}else{Battery.unobserve('level',this._boundRefreshText);Battery.unobserve('state',this._boundRefreshText);}}};return function ctor_batteryItem(element){return new BatteryItem(element);};});define('panels/root/findmydevice_item',['require'],function(require){'use strict';function FindMyDeviceItem(element){this._itemEnabled=false;this._FMDEnabled=false;this._boundRefreshText=this._refreshText.bind(this,element);this._boundFMDEnabledChanged=this._onFMDEnabledChanged.bind(this);}
FindMyDeviceItem.prototype={_refreshText:function fmd_refresh_text(element){if(!navigator.mozL10n){return;}
element.setAttribute('data-l10n-id',this._FMDEnabled?'enabled':'disabled');element.hidden=false;},_onFMDEnabledChanged:function fmd_enabled_changed(value){this._FMDEnabled=value;if(this._itemEnabled){this._boundRefreshText();}},get enabled(){return this._itemEnabled;},set enabled(value){if(this._itemEnabled===value){return;}
this._itemEnabled=value;if(this._itemEnabled){SettingsListener.observe('findmydevice.enabled',false,this._boundFMDEnabledChanged);}else{SettingsListener.unobserve('findmydevice.enabled',this._boundFMDEnabledChanged);}}};return function ctor_findMyDeviceItem(element){return new FindMyDeviceItem(element);};});define('panels/root/storage_usb_item',['require','shared/settings_listener','shared/async_storage','modules/settings_cache','modules/settings_service'],function(require){'use strict';var SettingsListener=require('shared/settings_listener');var AsyncStorage=require('shared/async_storage');var SettingsCache=require('modules/settings_cache');var SettingsService=require('modules/settings_service');function USBStorageItem(elements){this._enabled=false;this._elements=elements;this._umsSettingKey='ums.enabled';this._defaultMediaVolume=null;this._defaultVolumeState='available';this._defaultMediaVolumeKey='device.storage.writable.name';this._boundUmsSettingHandler=this._umsSettingHandler.bind(this);this._boundMediaVolumeChangeHandler=this._mediaVolumeChangeHandler.bind(this);}
USBStorageItem.prototype={get enabled(){return this._enabled;},set enabled(value){if(this._enabled===value){return;}else{this._enabled=value;}
if(value){this._elements.usbEnabledCheckBox.disabled=false;this._elements.usbEnabledCheckBox.addEventListener('change',this);SettingsListener.observe(this._umsSettingKey,false,this._boundUmsSettingHandler);SettingsListener.observe(this._defaultMediaVolumeKey,'sdcard',this._boundMediaVolumeChangeHandler);window.addEventListener('localized',this);this._elements.usbStorage.addEventListener('click',this._onItemClick);}else{this._elements.usbEnabledCheckBox.removeEventListener('change',this);SettingsListener.unobserve(this._umsSettingKey,this._boundUmsSettingHandler);SettingsListener.unobserve(this._defaultMediaVolumeKey,this._boundMediaVolumeChangeHandler);window.removeEventListener('localized',this);this._elements.usbStorage.removeEventListener('click',this._onItemClick);}},_umsSettingHandler:function storage_umsSettingHandler(enabled){this._elements.usbEnabledCheckBox.checked=enabled;this._updateUmsDesc();},_onItemClick:function storage_onItemClick(evt){SettingsService.navigate('usbStorage');},handleEvent:function storage_handleEvent(evt){switch(evt.type){case'localized':this._updateMediaStorageInfo();break;case'change':if(evt.target===this._elements.usbEnabledCheckBox){this._umsMasterSettingChanged(evt);}else{this._updateMediaStorageInfo();}
break;}},_updateUmsDesc:function storage_updateUmsDesc(){var key;if(this._elements.usbEnabledCheckBox.checked){key='enabled';}else if(this._defaultVolumeState==='shared'){key='umsUnplugToDisable';}else{key='disabled';}
this._elements.usbEnabledInfoBlock.setAttribute('data-l10n-id',key);},_umsMasterSettingChanged:function storage_umsMasterSettingChanged(evt){var checkbox=evt.target;var cset={};var warningKey='ums-turn-on-warning';if(checkbox.checked){AsyncStorage.getItem(warningKey,function(showed){if(!showed){this._elements.umsWarningDialog.hidden=false;this._elements.umsConfirmButton.onclick=function(){AsyncStorage.setItem(warningKey,true);this._elements.umsWarningDialog.hidden=true;SettingsCache.getSettings(this._openIncompatibleSettingsDialogIfNeeded.bind(this));}.bind(this);this._elements.umsCancelButton.onclick=function(){cset[this._umsSettingKey]=false;Settings.mozSettings.createLock().set(cset);checkbox.checked=false;this._elements.umsWarningDialog.hidden=true;}.bind(this);}else{SettingsCache.getSettings(this._openIncompatibleSettingsDialogIfNeeded.bind(this));}}.bind(this));}else{cset[this._umsSettingKey]=false;Settings.mozSettings.createLock().set(cset);}},_openIncompatibleSettingsDialogIfNeeded:function storage_openIncompatibleSettingsDialogIfNeeded(settings){var cset={};var umsSettingKey=this._umsSettingKey;var usbTetheringSetting=settings['tethering.usb.enabled'];if(!usbTetheringSetting){cset[umsSettingKey]=true;Settings.mozSettings.createLock().set(cset);}else{var oldSetting='tethering.usb.enabled';openIncompatibleSettingsDialog('incompatible-settings-warning',umsSettingKey,oldSetting,null);}},_mediaVolumeChangeHandler:function storage_mediaVolumeChangeHandler(defaultName){if(this._defaultMediaVolume){this._defaultMediaVolume.removeEventListener('change',this);}
this._defaultMediaVolume=this._getDefaultVolume(defaultName);if(this._defaultMediaVolume){this._defaultMediaVolume.addEventListener('change',this);}
this._updateMediaStorageInfo();},_updateMediaStorageInfo:function storage_updateMediaStorageInfo(){if(!this._defaultMediaVolume){this._updateVolumeState(null,'unavailable');return;}
var self=this;this._defaultMediaVolume.available().onsuccess=function(evt){var state=evt.target.result;var firstVolume=navigator.getDeviceStorages('sdcard')[0];if(state==='unavailable'&&self._defaultMediaVolume.storageName!==firstVolume.storageName){firstVolume.available().onsuccess=function(e){self._updateVolumeState(firstVolume,e.target.result);};}else{self._updateVolumeState(self._defaultMediaVolume,state);}};},_updateVolumeState:function storage_updateVolumeState(volume,state){this._defaultVolumeState=state;this._updateUmsDesc();switch(state){case'available':this._updateMediaFreeSpace(volume);this._lockMediaStorageMenu(false);break;case'shared':this._elements.mediaStorageDesc.removeAttribute('data-l10n-id');this._elements.mediaStorageDesc.textContent='';this._lockMediaStorageMenu(false);break;case'unavailable':this._elements.mediaStorageDesc.setAttribute('data-l10n-id','no-storage');this._lockMediaStorageMenu(true);break;}},_updateMediaFreeSpace:function storage_updateMediaFreeSpace(volume){var self=this;volume.freeSpace().onsuccess=function(e){DeviceStorageHelper.showFormatedSize(self._elements.mediaStorageDesc,'availableSize',e.target.result);};},_lockMediaStorageMenu:function storage_setMediaMenuState(lock){if(lock){this._elements.mediaStorageSection.setAttribute('aria-disabled',true);}else{this._elements.mediaStorageSection.removeAttribute('aria-disabled');}},_getDefaultVolume:function storage_getDefaultVolume(name){var volumes=navigator.getDeviceStorages('sdcard');if(!name||name===''){return volumes[0];}
for(var i=0;i<volumes.length;++i){if(volumes[i].storageName===name){return volumes[i];}}
return volumes[0];}};return function ctor_usb_storage_item(elements){return new USBStorageItem(elements);};});define('panels/root/storage_app_item',['require','modules/app_storage'],function(require){'use strict';var AppStorage=require('modules/app_storage');function AppStorageItem(element){this._enabled=false;this._element=element;this._boundUpdateAppFreeSpace=this._updateAppFreeSpace.bind(this);}
AppStorageItem.prototype={get enabled(){return this._enabled;},set enabled(value){if(this._enabled===value){return;}else{this._enabled=value;}
if(value){AppStorage.storage.observe('freeSize',this._boundUpdateAppFreeSpace);this._updateAppFreeSpace();window.addEventListener('localized',this);}else{AppStorage.storage.unobserve('freeSize',this._boundUpdateAppFreeSpace);window.removeEventListener('localized',this);}},_updateAppFreeSpace:function storage_updateAppFreeSpace(){DeviceStorageHelper.showFormatedSize(this._element,'availableSize',AppStorage.storage.freeSize);},handleEvent:function storage_handleEvent(evt){switch(evt.type){case'localized':this._updateAppFreeSpace();break;}}};return function ctor_app_storage_item(element){return new AppStorageItem(element);};});define('panels/root/wifi_item',['require','modules/wifi_context'],function(require){'use strict';var WifiContext=require('modules/wifi_context');var wifiManager=navigator.mozWifiManager;function WifiItem(element){this._enabled=false;this._boundUpdateWifiDesc=this._updateWifiDesc.bind(this,element);}
WifiItem.prototype={set enabled(value){if(value===this._enabled||!wifiManager){return;}
this._enabled=value;if(this._enabled){this._boundUpdateWifiDesc();WifiContext.addEventListener('wifiStatusTextChange',this._boundUpdateWifiDesc);}else{WifiContext.removeEventListener('wifiStatusTextChange',this._boundUpdateWifiDesc);}},get enabled(){return this._enabled;},_updateWifiDesc:function root_updateWifiDesc(element){element.setAttribute('data-l10n-id',WifiContext.wifiStatusText.id);if(WifiContext.wifiStatusText.args){element.setAttribute('data-l10n-args',JSON.stringify(WifiContext.wifiStatusText.args));}else{element.removeAttribute('data-l10n-args');}}};return function ctor_wifiItem(element){return new WifiItem(element);};});define('panels/root/screen_lock_item',['require','shared/settings_listener'],function(require){'use strict';var SettingsListener=require('shared/settings_listener');function ScreenLockItem(element){this._itemEnabled=false;this._observedKey='lockscreen.enabled';this._element=element;this._boundUpdateUI=this._updateUI.bind(this);}
ScreenLockItem.prototype={set enabled(value){if(value===this._itemEnabled){return;}else{this._itemEnabled=value;if(this._itemEnabled){SettingsListener.observe(this._observedKey,false,this._boundUpdateUI);}else{SettingsListener.unobserve(this._observedKey,this._boundUpdateUI);}}},get enabled(){return this._itemEnabled;},_updateUI:function sl_updateUI(enabled){var l10nId=enabled?'enabled':'disabled';this._element.setAttribute('data-l10n-id',l10nId);}};return function ctor_screen_lock_item(element){return new ScreenLockItem(element);};});define('panels/root/sim_security_item',['require','shared/simslot_manager','shared/airplane_mode_helper','modules/sim_security'],function(require){'use strict';var SIMSlotManager=require('shared/simslot_manager');var AirplaneModeHelper=require('shared/airplane_mode_helper');var SimSecurity=require('modules/sim_security');function SimSecurityItem(element){this._element=element;this._itemEnabled=false;this._cardIndex=0;this._activeSlot=this._getActiveSlot();this._boundUpdateUI=this._updateUI.bind(this);SimSecurity.addEventListener('pin-enabled',()=>{this._boundUpdateUI();});SimSecurity.addEventListener('pin-disabled',()=>{this._boundUpdateUI();});}
SimSecurityItem.prototype={set enabled(enabled){if(SIMSlotManager.isMultiSIM()||!this._activeSlot||enabled===this._itemEnabled){return;}
this._itemEnabled=enabled;if(this._itemEnabled){this._boundUpdateUI();AirplaneModeHelper.addEventListener('statechange',this._boundUpdateUI);}else{AirplaneModeHelper.removeEventListener('statechange',this._boundUpdateUI);}},get enabled(){return this._itemEnabled;},_updateUI:function(){var promise=new Promise((resolve)=>{AirplaneModeHelper.ready(()=>{this._element.style.fontStyle='italic';var airplaneModeStatus=AirplaneModeHelper.getStatus();if(airplaneModeStatus==='enabled'){this._element.setAttribute('data-l10n-id','simCardNotReady');return resolve();}
var cardState=this._activeSlot.simCard.cardState;switch(cardState){case null:this._element.setAttribute('data-l10n-id','noSimCard');return resolve();case'unknown':this._element.setAttribute('data-l10n-id','unknownSimCardState');return resolve();}
this._element.style.fontStyle='normal';SimSecurity.getCardLock(this._cardIndex,'pin').then((result)=>{var enabled=result.enabled;this._element.setAttribute('data-l10n-id',enabled?'enabled':'disabled');return resolve();});});});return promise;},_getActiveSlot:function(){var slot=SIMSlotManager.get(this._cardIndex);if(slot&&!slot.isAbsent()){return slot;}}};return function ctor_sim_security_item(element){return new SimSecurityItem(element);};});define('panels/root/low_priority_items',['require','panels/root/bluetooth_item','panels/root/nfc_item','panels/root/language_item','panels/root/battery_item','panels/root/findmydevice_item','panels/root/storage_usb_item','panels/root/storage_app_item','panels/root/wifi_item','panels/root/screen_lock_item','panels/root/sim_security_item'],function(require){'use strict';var items={BluetoothItem:require('panels/root/bluetooth_item'),NFCItem:require('panels/root/nfc_item'),LanguageItem:require('panels/root/language_item'),BatteryItem:require('panels/root/battery_item'),FindMyDeviceItem:require('panels/root/findmydevice_item'),StorageUSBItem:require('panels/root/storage_usb_item'),StorageAppItem:require('panels/root/storage_app_item'),WifiItem:require('panels/root/wifi_item'),ScreenLockItem:require('panels/root/screen_lock_item'),SimSecurityItem:require('panels/root/sim_security_item')};return{get BluetoothItem(){return items.BluetoothItem;},get NFCItem(){return items.NFCItem;},get LanguageItem(){return items.LanguageItem;},get BatteryItem(){return items.BatteryItem;},get FindMyDeviceItem(){return items.FindMyDeviceItem;},get StorageUSBItem(){return items.StorageUSBItem;},get StorageAppItem(){return items.StorageAppItem;},get WifiItem(){return items.WifiItem;},get ScreenLockItem(){return items.ScreenLockItem;},get SimSecurityItem(){return items.SimSecurityItem;}};});